#!/usr/bin/python
# -*- coding: UTF-8 -*-

"""
    Huawei DLI Python SDK
    The Queue class of DLI Python SDK
"""
from pprint import pformat


class Queue(object):

    def __init__(self, queue_info):
        self._queue_info = queue_info

    def to_dict(self):
        result = {
            'queue_name': self.name,
            'owner': self.owner,
            'cu_count': self.cu_count,
            'charging_mode': self.charging_mode,
            'description': self.description
        }
        return result

    def to_str(self):
        return pformat(self.to_dict())

    def __repr__(self):
        return self.to_str()

    @property
    def name(self):
        return self._queue_info.queue_name

    @property
    def cu_count(self):
        return self._queue_info.cu_count

    @property
    def owner(self):
        return self._queue_info.owner

    @property
    def charging_mode(self):
        return self._queue_info.charging_mode

    @property
    def description(self):
        return self._queue_info.description
