#!/usr/bin/python
# -*- coding: UTF-8 -*-

import time


class Row(object):
    def __init__(self, schema, columns):
        """

        :param list schema:
        :param list columns:
        """
        self._schema = schema
        self._row = Row._get_row(schema, columns)

    @staticmethod
    def _get_row(schema, columns):
        tmp_row = []
        for idx in range(len(columns)):
            tmp_row.append(Row._get_column(schema[idx].type, columns[idx]))

        return tmp_row

    @staticmethod
    def _get_column(type_string, value_string):
        if value_string is None:
            return None

        if type_string == 'int' or type_string == 'short' or type_string == 'smallint':
            return int(value_string)
        elif type_string == 'bigint' or type_string == 'long':
            return int(value_string)
        elif type_string == 'float' or type_string == 'double':
            return float(value_string)
        elif type_string == 'boolean':
            if value_string == 'False':
                return False
            return True
        elif type_string == 'timestamp':
            tm = int(value_string)
            tm /= 1000
            time_arr = time.gmtime(tm)
            return time.strftime('%Y-%m-%d %H:%M:%SZ', time_arr)
        else:
            return value_string

    @property
    def columns(self):
        return self._row

    def to_str(self):
        return str(self.columns)

    def __repr__(self):
        return self.to_str()
